/*  Hr r ngra C-funktioner, frmst fr in- och utmatning,
 *  som kanske kan vara anvndbara
 *  - srskilt fr den som inte r s van vid text-I/O i C.
 *
 *  Gratis programvara utan garanti. Anvnd den hur ni vill, men skyll inte p mig.
 *
 *  Kompilerat och provkrt, utan ndringar, p:
 *   Red Hat Linux 8.0, gcc 3.2, unixODBC 2.2.2
 *     Som C: gcc -Wall -o testa-c-funktionerna testa-c-funktionerna.c c-funktioner.c
 *     Som C++: g++ -Wall -o testa-c-funktionerna testa-c-funktionerna.cc c-funktioner.cc
 *   Windows 2000 Professional, Microsoft Visual C++ 6.0
 *   Windows 2000 Professional, Borland C++ Builder 5.0
 *
 *  Thomas Padron-McCarthy (Thomas.Padron-McCarthy@tech.oru.se)
 *  Denna fil senast ndrad: 18 maj 2004
 */

/*---------------------------------------------------------------------------*/

/*  Funktionen "fatal_error" skriver ut ett felmeddelande och avslutar
 *  programmet. Den anropas med en formatstrng och ytterligare argument
 *  p samma stt som printf.
 */

extern void fatal_error(char* format_string, ...);

/*---------------------------------------------------------------------------*/

/*  Det hr r "skra" versioner av minnesallokeringsfunktionerna
 *  "malloc", "free" m fl. De anropar "fatal_arror" om det inte gick att
 *  allokera det nskade minnet.
 *  Dessutom grs en del kontroller s att funktionerna ska flja
 *  C-standarden ven om biblioteksfunktionerna kanske inte gr det.
 */

extern void *safe_malloc(size_t s);
extern void *safe_calloc(size_t n, size_t s);
extern void *safe_realloc(void *p, size_t s);
extern void safe_free(void *p);

/*---------------------------------------------------------------------------*/

/*  Den hr funktionen returnerar 1 om anvndaren svarar 'j', 0 om 'n'.
 *  Om man skriver ngot annat frgar den om.
 */

extern int ask_yes_or_no(char *question);

/*---------------------------------------------------------------------------*/

/*  "smart_fgets" r en mer "praktisk" variant av funktionen "fgets".
 *  Den gr en del kontroller, och det avslutande radslutstecknet
 *  kommer inte med i bufferten, utan kastas bara bort.
 *  "buffer" ska peka p den plats dr den inlsta raden ska lagras,
 *  "buffer_size" r storleken p "buffer" (inklusive den avslutande nul-byten),
 *  och "instream" r den ppna fil man ska lsa frn.
 */

extern char *smart_fgets(char *buffer, int buffer_size, FILE *instream);

/*---------------------------------------------------------------------------*/

/*  Funktionen "f_read_line" lser en hel rad frn filen "infile"
 *  och returnerar den i en malloc-allokerad strng.
 *  Det avslutande radslutstecknet kommer inte med i bufferten,
 *  utan kastas bara bort.
 *  Vid filslut returneras NULL.
 */

extern char *f_read_line(FILE *infile);

/*---------------------------------------------------------------------------*/

/*  Funktionen "read_line" lser en hel rad frn standardinmatningen
 *  och returnerar den i en malloc-allokerad strng.
 *  Det avslutande radslutstecknet kommer inte med i bufferten,
 *  utan kastas bara bort.
 *  Vid filslut returneras NULL.
 */

extern char *read_line(void);

/*---------------------------------------------------------------------------*/

/*  Funktionen "f_read_integer" lser ett heltal frn filen "infile",
 *  och returnerar det heltalet.
 */

extern int f_read_integer(FILE *infile);

/*---------------------------------------------------------------------------*/

/*  Funktionen "read_integer" lser ett heltal frn standardinmatningen,
 *  och returnerar det heltalet.
 */

extern int read_integer(void);

/*---------------------------------------------------------------------------*/

/*  Funktionen "f_read_integer_line" lser en rad frn filen "infile",
 *  kollar att den raden verkligen innehller ett heltal,
 *  och returnerar det heltalet.
 */

extern int f_read_integer_line(FILE *infile);

/*---------------------------------------------------------------------------*/

/*  Funktionen "read_integer_line" lser en rad frn standardinmatningen,
 *  kollar att den raden verkligen innehller ett heltal,
 *  och returnerar det heltalet.
 */

extern int read_integer_line(void);

/*---------------------------------------------------------------------------*/

/* Den hr funktionen "kapar bort" blanktecken p slutet i en strng: */

extern void skip_trailing_space(char *str);

/*---------------------------------------------------------------------------*/

/*  Den hr funktionen "slr ihop" tv strngar genom att malloc-allokera
 *  plats fr resultatet, kopiera dit bda strngarna, och returnera
 *  en pekare till den malloc-allokerade strngen.
 */

extern char *add_strings(char *str1, char *str2);

/*---------------------------------------------------------------------------*/
